image: docker:latest

services:
  - docker:dind

variables:
  DOCKER_DRIVER: overlay
  REGISTRY_BASE: registry.gitlab.com/chvote2/infra
  IMAGE_NAME: spring-boot
  TAG_STAGING: staging-openjdk11
  TAG: openjdk11

stages:
  - build
  - deploy

before_script:
  - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN registry.gitlab.com

build-staging-image:
  stage: build
  script:
    - docker build -t $REGISTRY_BASE/$IMAGE_NAME:$TAG_STAGING .
    - docker push $REGISTRY_BASE/$IMAGE_NAME:$TAG_STAGING

deploy-tag-to-registry:
  stage: deploy
  script:
    - docker pull $REGISTRY_BASE/$IMAGE_NAME:$TAG_STAGING
    - docker tag $REGISTRY_BASE/$IMAGE_NAME:$TAG_STAGING $REGISTRY_BASE/$IMAGE_NAME:$TAG
    - docker push $REGISTRY_BASE/$IMAGE_NAME:$TAG

